
  <!DOCTYPE html>
  <html>
    <head>
      <title>index.tsx</title>
      <link href="https://cdn.jsdelivr.net/npm/semantic-ui@2.4.2/dist/semantic.min.css" type="text/css" rel="stylesheet">
      <script src="https://cdnjs.cloudflare.com/ajax/libs/codemirror/5.58.2/codemirror.min.js" type="text/javascript" charset="utf-8"></script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/codemirror/5.58.2/mode/javascript/javascript.min.js" type="text/javascript" charset="utf-8"></script>
<link href="https://cdnjs.cloudflare.com/ajax/libs/codemirror/5.58.2/codemirror.min.css" type="text/css" rel="stylesheet">
<script src="../../../../assets/source-file.js" type="text/javascript" charset="utf-8"></script>
<link href="../../../../assets/source-file.css" type="text/css" rel="stylesheet">
    </head>
    <body>
    <div style="margin-top:3em" class="ui container"><h1 class="ui header"><a href="../../../../index.html">TypeScript coverage report</a></h1><table style="margin-top:2em" class="ui celled table"><thead class=""><tr class=""><th class="">Filename</th><th class="">Percent</th><th class="">Threshold</th><th class="">Total</th><th class="">Covered</th><th class="">Uncovered</th></tr></thead><tbody class=""><tr class="positive"><td class="">src/pages/simulation/index.tsx</td><td class="">92.39%</td><td class="">80%</td><td class="">1143</td><td class="">1056</td><td class="">87</td></tr></tbody></table><textarea id="editor" readonly="" style="margin-top:3em">import React, { useCallback, useMemo, useState } from &#x27;react&#x27;;

import s from &#x27;./model-configuring.module.scss&#x27;;
import { Header } from &#x27;../../components/Header/Header&#x27;;
import {
  Graphic,
  Heading,
  HeadingVariant,
  SelectedPoint
} from &#x27;../../components&#x27;;
import { Button, ButtonVariant } from &#x27;../../components/Button/Button&#x27;;
import { ReactComponent as SimulationIcon } from &#x27;./assets/simulation.svg&#x27;;
import { Table } from &#x27;../../components/Table/Table&#x27;;
import { useParams } from &#x27;react-router-dom&#x27;;
import { useRunSimulation } from &#x27;../../queries/simulation&#x27;;
import { ProjectBreadcrumbs } from &#x27;../project-settings&#x27;;
import { useInitialData, useProject } from &#x27;../../queries/projects&#x27;;
import { LastSaved } from &#x27;../model-configuring&#x27;;
import {
  FieldSpec,
  FormWrapper,
  useValidate
} from &#x27;../project-settings/components/FormContext&#x27;;
import { FormFieldFloatTextValue } from &#x27;../project-settings/components/FormFieldFloatTextValue&#x27;;
import { useRenderTooltip } from &#x27;../fitting/hooks/useRenderTooltip&#x27;;
import { useLines } from &#x27;./hooks/useLines&#x27;;
import { useXAxis } from &#x27;./hooks/useXAxis&#x27;;

const Info = &lt;Key extends string&gt;({
  fields,
  title
}: {
  title: string;
  fields: { name: string; value: Key }[];
}) =&gt; {
  return (
    &lt;div className={s.Info}&gt;
      &lt;div className={s.Info__title}&gt;{title}&lt;/div&gt;
      &lt;div className={s.Info__content}&gt;
        {fields.map((field) =&gt; {
          return (
            &lt;div className={s.Info__item} key={field.value}&gt;
              &lt;div className={s.Info__itemName}&gt;{field.name}&lt;/div&gt;
              &lt;div className={s.Info__itemValue}&gt;
                &lt;FormFieldFloatTextValue fieldName={field.value} /&gt;
              &lt;/div&gt;
            &lt;/div&gt;
          );
        })}
      &lt;/div&gt;
    &lt;/div&gt;
  );
};

export enum SimulationMode {
  perfusion_optimizer = 1,
  intensified_growth = 2,
  centrifuge_perfusion = 3,
  general_simulation = 4
}

const mapSimulationModeToParameters = {
  [SimulationMode.perfusion_optimizer]: [
    {
      value: &#x27;volumetric_exchange_rate&#x27;,
      name: &#x27;Volumetric exchange rate&#x27;
    },
    {
      value: &#x27;target_viability&#x27;,
      name: &#x27;Target viability&#x27;
    },
    {
      value: &#x27;simulation_duration&#x27;,
      name: &#x27;Duration (Days)&#x27;
    }
  ],
  [SimulationMode.intensified_growth]: [
    {
      value: &#x27;cell_specific_exchange_rate&#x27;,
      name: &#x27;Cell specific exchange rate&#x27;
    },
    {
      value: &#x27;target_viable_cell_denisty&#x27;,
      name: &#x27;Target viable cell density&#x27;
    },
    {
      value: &#x27;maximum_growth_time&#x27;,
      name: &#x27;Duration (Days)&#x27;
    }
  ],
  [SimulationMode.centrifuge_perfusion]: [
    {
      value: &#x27;target_viable_cell_denisty&#x27;,
      name: &#x27;Target viable cell density&#x27;
    },
    {
      value: &#x27;simulation_duration&#x27;,
      name: &#x27;Duration (Days)&#x27;
    },
    {
      value: &#x27;media_exchange_start_time&#x27;,
      name: &#x27;Media exchange start time&#x27;
    },
    {
      value: &#x27;media_exchange_ratio&#x27;,
      name: &#x27;Media exchange ratio&#x27;
    },
    {
      value: &#x27;media_exchange_frequency&#x27;,
      name: &#x27;Media exchange frequency&#x27;
    }
  ],
  [SimulationMode.general_simulation]: [
    {
      value: &#x27;volumetric_exchange_rate&#x27;,
      name: &#x27;Volumetric exchange rate&#x27;
    },
    {
      value: &#x27;target_viable_cell_denisty&#x27;,
      name: &#x27;Target viable cell density&#x27;
    },
    {
      value: &#x27;simulation_duration&#x27;,
      name: &#x27;Duration (Days)&#x27;
    }
  ]
};

const mapSimulationModeToFieldSpecs: { [key in SimulationMode]: FieldSpec[] } =
  {
    [SimulationMode.perfusion_optimizer]: [
      { name: &#x27;volumetric_exchange_rate&#x27;, type: &#x27;float&#x27;, min: 0, max: 5 },
      { name: &#x27;target_viability&#x27;, type: &#x27;float&#x27;, min: 0, max: 1 },

      { name: &#x27;simulation_duration&#x27;, type: &#x27;float&#x27;, min: 10, max: 100 }
    ],
    [SimulationMode.intensified_growth]: [
      { name: &#x27;cell_specific_exchange_rate&#x27;, type: &#x27;float&#x27;, min: 0, max: 200 },
      { name: &#x27;target_viable_cell_denisty&#x27;, type: &#x27;float&#x27;, min: 0, max: 200 },

      { name: &#x27;maximum_growth_time&#x27;, type: &#x27;float&#x27;, min: 0, max: 25 }
    ],
    [SimulationMode.centrifuge_perfusion]: [
      { name: &#x27;target_viable_cell_denisty&#x27;, type: &#x27;float&#x27;, min: 0, max: 200 },
      { name: &#x27;simulation_duration&#x27;, type: &#x27;float&#x27;, min: 10, max: 100 },

      { name: &#x27;media_exchange_start_time&#x27;, type: &#x27;float&#x27;, min: 0, max: 100 },
      { name: &#x27;media_exchange_ratio&#x27;, type: &#x27;float&#x27;, min: 0, max: 1 },
      { name: &#x27;media_exchange_frequency&#x27;, type: &#x27;float&#x27;, min: 0.1, max: 3 }
    ],
    [SimulationMode.general_simulation]: [
      { name: &#x27;volumetric_exchange_rate&#x27;, type: &#x27;float&#x27;, min: 0, max: 5 },
      { name: &#x27;target_viable_cell_denisty&#x27;, type: &#x27;float&#x27;, min: 0, max: 200 },

      { name: &#x27;simulation_duration&#x27;, type: &#x27;float&#x27;, min: 10, max: 100 }
    ]
  };
const simulationModes = [
  {
    name: &#x27;Perfusion optimizer&#x27;,
    value: SimulationMode.perfusion_optimizer
  },
  {
    name: &#x27;Intensified growth&#x27;,
    value: SimulationMode.intensified_growth
  },
  {
    name: &#x27;Centrifuge perfusion&#x27;,
    value: SimulationMode.centrifuge_perfusion
  },
  {
    name: &#x27;General simulation&#x27;,
    value: SimulationMode.general_simulation
  }
];

const RESTRICTED_COLUMNS = [
  &#x27;BatchID&#x27;,
  &#x27;BatchId&#x27;,
  &#x27;Cell viability&#x27;,
  &#x27;Time&#x27;,
  &#x27;Viable cell density&#x27;
];
const initialVariablesFieldsSpec: FieldSpec[] = [
  {
    name: &#x27;initial_viable_cell_density&#x27;,
    type: &#x27;float&#x27;,
    min: 0.1,
    max: 20
  },
  {
    name: &#x27;initial_viability&#x27;,
    type: &#x27;float&#x27;,
    min: 0.5,
    max: 1
  },
  {
    name: &#x27;initial_lysed_cell_density&#x27;,
    type: &#x27;float&#x27;,
    min: 0,
    max: 100
  },
  {
    name: &#x27;initial_biomaterial&#x27;,
    type: &#x27;float&#x27;,
    min: 0,
    max: 1000
  }
];

const RecalculationBlock = ({
  selectedSimulationMode,
  onChangeSimulationMode,
  runSimulation,
  disabled
}: {
  selectedSimulationMode: SimulationMode;
  onChangeSimulationMode: (newSimulationMode: SimulationMode) =&gt; void;
  runSimulation: () =&gt; void;
  disabled?: boolean;
}) =&gt; {
  const validate = useValidate();
  const handleRunSimulation = useCallback(() =&gt; {
    if (Object.keys(validate()).length === 0) {
      runSimulation();
    }
  }, [validate, runSimulation]);
  return (
    &lt;div className={s.Fitting__recalculateWrapper}&gt;
      &lt;div&gt;
        &lt;div className={s.Fitting__recalculateLabel}&gt;Simulation Mode&lt;/div&gt;
        &lt;div className={s.Fitting__recalculateSelectWrapper}&gt;
          &lt;select
            value={selectedSimulationMode}
            onChange={(e) =&gt;
              onChangeSimulationMode(
                parseInt(e.target.value, 10) as SimulationMode
              )
            }
            className={s.Fitting__recalculateSelect}
          &gt;
            &lt;option value=&quot;-1&quot;&gt;Select simulation mode&lt;/option&gt;
            {simulationModes.map((simulationMode) =&gt; (
              &lt;option key={simulationMode.name} value={simulationMode.value}&gt;
                {simulationMode.name}
              &lt;/option&gt;
            ))}
          &lt;/select&gt;
        &lt;/div&gt;
      &lt;/div&gt;
      &lt;Button
        hoverVariant={ButtonVariant.ACTION}
        rightIcon={&lt;SimulationIcon /&gt;}
        uppercase
        size=&quot;small&quot;
        disabled={disabled}
        onClick={handleRunSimulation}
      &gt;
        Run simulation
      &lt;/Button&gt;
    &lt;/div&gt;
  );
};

type InitialFields = {
  initial_viability: number;
  initial_viable_cell_density: number;
  initial_biomaterial: number;
  initial_lysed_cell_density: number;
};

type PerfusionOptimizerFields = {
  volumetric_exchange_rate: number;
  target_viability: number;
  simulation_duration: number;
};
type IntensifiedGrowthFields = {
  cell_specific_exchange_rate: number;
  target_viable_cell_denisty: number;
  maximum_growth_time: number;
};
type CentrifugePerfusionFields = {
  target_viable_cell_denisty: number;
  simulation_duration: number;
  media_exchange_start_time: number;
  media_exchange_ratio: number;
  media_exchange_frequency: number;
};
type GeneralSimulationFields = {
  volumetric_exchange_rate: number;
  target_viable_cell_denisty: number;
  simulation_duration: number;
};

type SimulationFields =
  | PerfusionOptimizerFields
  | IntensifiedGrowthFields
  | CentrifugePerfusionFields
  | GeneralSimulationFields;

type Fields = SimulationFields &amp; InitialFields;

const mapFieldsToSimulationParameters = (
  fields: Fields,
  simulationMode: SimulationMode
) =&gt; {
  switch (simulationMode) {
    case SimulationMode.general_simulation: {
      return {
        volumetric_exchange_rate: (fields as GeneralSimulationFields)
          .volumetric_exchange_rate,
        target_viable_cell_denisty: (fields as GeneralSimulationFields)
          .target_viable_cell_denisty,
        simulation_duration: (fields as GeneralSimulationFields)
          .simulation_duration
      };
    }
    case SimulationMode.centrifuge_perfusion: {
      return {
        target_viable_cell_denisty: (fields as CentrifugePerfusionFields)
          .target_viable_cell_denisty,
        simulation_duration: (fields as CentrifugePerfusionFields)
          .simulation_duration,
        media_exchange_start_time: (fields as CentrifugePerfusionFields)
          .media_exchange_start_time,
        media_exchange_ratio: (fields as CentrifugePerfusionFields)
          .media_exchange_ratio,
        media_exchange_frequency: (fields as CentrifugePerfusionFields)
          .media_exchange_frequency
      };
    }
    case SimulationMode.intensified_growth: {
      return {
        cell_specific_exchange_rate: (fields as IntensifiedGrowthFields)
          .cell_specific_exchange_rate,
        target_viable_cell_denisty: (fields as IntensifiedGrowthFields)
          .target_viable_cell_denisty,
        maximum_growth_time: (fields as IntensifiedGrowthFields)
          .maximum_growth_time
      };
    }
    case SimulationMode.perfusion_optimizer: {
      return {
        volumetric_exchange_rate: (fields as PerfusionOptimizerFields)
          .volumetric_exchange_rate,
        target_viability: (fields as PerfusionOptimizerFields).target_viability,
        simulation_duration: (fields as PerfusionOptimizerFields)
          .simulation_duration
      };
    }
  }
};

const mapFieldsToInitialConditions = (fields: Fields) =&gt; {
  return {
    initial_viability: fields.initial_viability,
    initial_viable_cell_density: fields.initial_viable_cell_density,
    initial_biomaterial: fields.initial_biomaterial,
    initial_lysed_cell_density: fields.initial_lysed_cell_density
  };
};
const initialConditions = {
  initial_viability: 0.94,
  initial_viable_cell_density: 0.2,
  initial_biomaterial: 0,
  initial_lysed_cell_density: 0
};

const simulationParameters = {
  [SimulationMode.perfusion_optimizer]: {
    volumetric_exchange_rate: 2,
    target_viability: 0.925,
    simulation_duration: 40
  },
  [SimulationMode.intensified_growth]: {
    cell_specific_exchange_rate: 40,
    target_viable_cell_denisty: 80,
    maximum_growth_time: 14
  },
  [SimulationMode.centrifuge_perfusion]: {
    target_viable_cell_denisty: 80,
    simulation_duration: 40,
    media_exchange_start_time: 3,
    media_exchange_ratio: 0.7,
    media_exchange_frequency: 1
  },
  [SimulationMode.general_simulation]: {
    volumetric_exchange_rate: 2,
    target_viable_cell_denisty: 80,
    simulation_duration: 40
  }
};

const INITIAL_CONDITIONS_FIELDS = [
  {
    name: &#x27;Initial Viable Cell Density&#x27;,
    value: &#x27;initial_viable_cell_density&#x27;
  },
  {
    name: &#x27;Initial Viability&#x27;,
    value: &#x27;initial_viability&#x27;
  },
  {
    name: &#x27;Initial Lysed Cells&#x27;,
    value: &#x27;initial_lysed_cell_density&#x27;
  },
  {
    name: &#x27;Initial Biomaterial&#x27;,
    value: &#x27;initial_biomaterial&#x27;
  }
];
export const SimulationPage = () =&gt; {
  const { projectId } = useParams&lt;{ projectId: string }&gt;();
  const {
    mutate: mutateRunSimulation,
    data = [],
    isLoading
  } = useRunSimulation(projectId);
  const tableRows = useMemo(() =&gt; {
    return (
      data?.map(({ batchName, data }) =&gt; {
        const parameterNames = Object.keys(data);
        const res: { [key: string]: string | number } = {
          BatchId: batchName
        };
        parameterNames.forEach((parameterName) =&gt; {
          res[parameterName] = (data as any)[parameterName][
            (data as any)[parameterName].length - 1
          ];
        });
        return res;
      }) || []
    );
  }, [data]);
  const project = useProject(projectId);
  const initialData = useInitialData(projectId);
  const [selectedSimulationMode, setSelectedSimulationMode] = useState&lt;
    SimulationMode | -1
  &gt;(-1);

  const [fields, setFields] = useState&lt;Partial&lt;Fields&gt;&gt;({});

  const viableCellDensity = useMemo(() =&gt; {
    return data
      ?.flatMap(({ batchName, data }) =&gt;
        (data as any)[&#x27;Viable cell density&#x27;].map((v: number, idx: number) =&gt; ({
          [batchName]: v,
          x: (data as any)[&#x27;Time&#x27;][idx],
          batchId: batchName
        }))
      )
      .sort((a, b) =&gt; a.x - b.x);
  }, [data]);

  const tableColumns = useMemo(() =&gt; {
    return Object.keys(
      tableRows.reduce((acc, row) =&gt; ({ ...acc, ...row }), {})
    );
  }, [tableRows]);

  const computedByScriptColumns = useMemo(() =&gt; {
    return tableColumns.filter((col) =&gt; !RESTRICTED_COLUMNS.includes(col));
  }, [tableColumns]);
  const [selected1, setSelected1] = useState(&#x27;&#x27;);
  const variableSelector1 = useMemo(() =&gt; {
    if (!selected1) return [];
    if (computedByScriptColumns.includes(selected1)) {
      return data
        ?.flatMap(({ batchName, data }) =&gt;
          (data as any)[&#x27;Viable cell density&#x27;].map(
            (v: number, idx: number) =&gt; ({
              [batchName]: (data as any)[selected1][idx],
              x: (data as any)[&#x27;Time&#x27;][idx],
              batchId: batchName
            })
          )
        )
        .sort((a, b) =&gt; a.x - b.x);
    }
    return initialData.data?.map((row: any) =&gt; {
      const batchId = project.project?.columns_map?.BatchID
        ? row[project.project.columns_map.BatchID]
        : row.BatchID;
      const time = project.project?.columns_map?.Time
        ? row[project.project.columns_map.Time]
        : row.Time;
      return {
        [batchId]: row[selected1],
        x: time,
        batchId
      };
    });
  }, [computedByScriptColumns, data, initialData.data, project, selected1]);

  const [selected2, setSelected2] = useState(&#x27;&#x27;);
  const variableSelector2 = useMemo(() =&gt; {
    if (!selected2) return [];
    console.log(&#x27;&gt;&gt;&gt; data:&#x27;, data, selected2, initialData);
    return data
      ?.flatMap(({ batchName, data }) =&gt;
        (data as any)[&#x27;Viable cell density&#x27;].map((v: number, idx: number) =&gt; {
          if ((data as any)[selected2]) {
            return {
              [batchName]: (data as any)[selected2][idx],
              x: (data as any)[&#x27;Time&#x27;][idx],
              batchId: batchName
            };
          } else {
            const time = (data as any)[&#x27;Time&#x27;][idx];
            const row = initialData.data?.find((row) =&gt; {
              const rowTime = (row as any)[
                project?.project?.columns_map?.Time || &#x27;Time&#x27;
              ];
              return rowTime === time;
            });
            return {
              [batchName]: (row as any)?.[selected2],
              x: (data as any)[&#x27;Time&#x27;][idx],
              batchId: batchName
            };
          }
        })
      )
      .sort((a, b) =&gt; a.x - b.x);
  }, [data, initialData, project?.project?.columns_map?.Time, selected2]);

  const initialDataColumns = useMemo(() =&gt; {
    if (!initialData.data) return [];
    const mappedRestrictedColumns = project.project?.columns_map
      ? RESTRICTED_COLUMNS.map(
          (col) =&gt; (project.project?.columns_map as any)[col] || col
        )
      : RESTRICTED_COLUMNS;

    return Object.keys(
      initialData.data.reduce(
        (acc, row) =&gt; ({ ...acc, ...row }),
        {} as { [key: string]: any }
      )
    ).filter(
      (column) =&gt;
        !mappedRestrictedColumns.includes(column) &amp;&amp;
        !RESTRICTED_COLUMNS.includes(column)
    );
  }, [project, initialData]);

  const variableSelectorColumns = useMemo(
    () =&gt;
      data &amp;&amp; data.length &gt; 0
        ? computedByScriptColumns.concat(initialDataColumns)
        : [],
    [computedByScriptColumns, data, initialDataColumns]
  );

  const handleRunSimulation = useCallback(() =&gt; {
    if (selectedSimulationMode !== -1) {
      mutateRunSimulation({
        simulation_mode: selectedSimulationMode,
        simulation_parameters: mapFieldsToSimulationParameters(
          fields as Fields,
          selectedSimulationMode
        ),
        initial_conditions: mapFieldsToInitialConditions(fields as Fields)
      });
    }
  }, [fields, mutateRunSimulation, selectedSimulationMode]);

  const simulationModeFieldsSpec: FieldSpec[] = useMemo(
    () =&gt;
      selectedSimulationMode === -1
        ? []
        : mapSimulationModeToFieldSpecs[selectedSimulationMode],
    [selectedSimulationMode]
  );
  const fieldsSpec = useMemo(
    () =&gt; initialVariablesFieldsSpec.concat(simulationModeFieldsSpec),
    [simulationModeFieldsSpec]
  );
  const defaultValues = useMemo(
    () =&gt; ({
      ...initialConditions,
      ...(selectedSimulationMode !== -1
        ? simulationParameters[selectedSimulationMode]
        : {})
    }),
    [selectedSimulationMode]
  );

  const [selectedPoints, onChangeSelectedPoints] = useState&lt;
    SelectedPoint&lt;string&gt;[]
  &gt;([]);
  const [selectedBatches, onChangeSelectedBatches] = useState&lt;string[]&gt;([]);
  // FIXME: not string type in &lt;&gt;
  const [selectedPoint, onSelectPoint] = useState&lt;SelectedPoint&lt;string&gt; | null&gt;(
    null
  );
  const vcdRenderTooltip = useRenderTooltip(&#x27;VCD&#x27;);
  const selected1RenderTooltip = useRenderTooltip(selected1);
  const selected2RenderTooltip = useRenderTooltip(selected2);
  const lines = useLines(data);
  const xAxis = useXAxis();
  const commonGraphicsProps = {
    xAxis,
    lines,
    selectedPoints,
    selectedBatches,
    onChangeSelectedBatches,
    onChangeSelectedPoints,
    selectedPoint,
    onSelectPoint,
    showIncludeExcludeControls: true
  };
  return (
    &lt;div className={s.ProjectSettings}&gt;
      &lt;FormWrapper
        fields={fields}
        setFields={setFields}
        defaultValues={defaultValues}
        fieldsSpec={fieldsSpec}
      &gt;
        &lt;Header /&gt;
        &lt;ProjectBreadcrumbs /&gt;
        &lt;div className={s.ProjectSettings__content}&gt;
          &lt;div className={s.ModelConfiguring__contentLeft}&gt;
            &lt;Heading
              className={s.ProjectSettings__headingH2}
              variant={HeadingVariant.H2}
            &gt;
              Simulation
            &lt;/Heading&gt;
            &lt;LastSaved /&gt;
          &lt;/div&gt;
        &lt;/div&gt;
        &lt;RecalculationBlock
          selectedSimulationMode={selectedSimulationMode}
          onChangeSimulationMode={setSelectedSimulationMode}
          runSimulation={handleRunSimulation}
          disabled={isLoading || selectedSimulationMode === -1}
        /&gt;
        &lt;div className={s.ModelConfiguring__frames}&gt;
          &lt;div&gt;
            &lt;div className={s.Fitting__infos}&gt;
              {selectedSimulationMode !== -1 &amp;&amp; (
                &lt;Info
                  title=&quot;Simulation Parameters&quot;
                  fields={mapSimulationModeToParameters[selectedSimulationMode]}
                /&gt;
              )}
              &lt;Info
                title=&quot;Initial Conditions&quot;
                fields={INITIAL_CONDITIONS_FIELDS}
              /&gt;
            &lt;/div&gt;
          &lt;/div&gt;
          &lt;div&gt;
            &lt;div&gt;
              &lt;div className={s.Fitting__recalculateLabel}&gt;
                Simulation Plots
              &lt;/div&gt;
              &lt;div className={s.Fitting__measuredVsPredictedFit}&gt;
                &lt;div
                  style={{
                    height: &#x27;700px&#x27;,
                    width: &#x27;100%&#x27;
                  }}
                &gt;
                  &lt;Graphic
                    data={viableCellDensity || []}
                    yAxisUnit=&quot;Viable cell density&quot;
                    renderTooltip={vcdRenderTooltip}
                    {...commonGraphicsProps}
                  /&gt;
                &lt;/div&gt;
                &lt;div className={s.Fitting__variableName}&gt;
                  Viable cell density
                &lt;/div&gt;
              &lt;/div&gt;
              &lt;div className={s.Fitting__variablesGraphics}&gt;
                &lt;div&gt;
                  &lt;div className={s.Fitting__variablesGraphicsSelect}&gt;
                    &lt;div className={s.Fitting__recalculateSelectWrapper}&gt;
                      &lt;select
                        value={selected1}
                        onChange={(e) =&gt; setSelected1(e.target.value)}
                        className={s.Fitting__recalculateSelect}
                      &gt;
                        &lt;option value=&quot;&quot;&gt;Select variable&lt;/option&gt;
                        {variableSelectorColumns.map((col) =&gt; (
                          &lt;option key={col} value={col}&gt;
                            {col}
                          &lt;/option&gt;
                        ))}
                      &lt;/select&gt;
                    &lt;/div&gt;
                  &lt;/div&gt;
                  &lt;div
                    style={{
                      marginTop: &#x27;10px&#x27;,
                      height: &#x27;400px&#x27;,
                      width: &#x27;35vw&#x27;
                    }}
                  &gt;
                    &lt;Graphic
                      data={
                        data &amp;&amp; data.length &gt; 0 ? variableSelector1 || [] : []
                      }
                      yAxisUnit={selected1}
                      renderTooltip={selected1RenderTooltip}
                      {...commonGraphicsProps}
                    /&gt;
                  &lt;/div&gt;
                &lt;/div&gt;
                &lt;div&gt;
                  &lt;div className={s.Fitting__variablesGraphicsSelect}&gt;
                    &lt;div className={s.Fitting__recalculateSelectWrapper}&gt;
                      &lt;select
                        value={selected2}
                        onChange={(e) =&gt; setSelected2(e.target.value)}
                        className={s.Fitting__recalculateSelect}
                      &gt;
                        &lt;option value=&quot;&quot;&gt;Select variable&lt;/option&gt;
                        {variableSelectorColumns.map((col) =&gt; (
                          &lt;option key={col} value={col}&gt;
                            {col}
                          &lt;/option&gt;
                        ))}
                      &lt;/select&gt;
                    &lt;/div&gt;
                  &lt;/div&gt;
                  &lt;div
                    style={{
                      marginTop: &#x27;10px&#x27;,
                      height: &#x27;400px&#x27;,
                      width: &#x27;35vw&#x27;
                    }}
                  &gt;
                    &lt;Graphic
                      data={
                        data &amp;&amp; data.length &gt; 0 ? variableSelector2 || [] : []
                      }
                      yAxisUnit={selected2}
                      renderTooltip={selected2RenderTooltip}
                      {...commonGraphicsProps}
                    /&gt;
                  &lt;/div&gt;
                &lt;/div&gt;
              &lt;/div&gt;
              &lt;div className={s.ModelConfiguring__tableFrame}&gt;
                &lt;div className={s.ModelConfiguring__tableName}&gt;
                  Summary Statistics
                &lt;/div&gt;
                &lt;div className={s.ModelConfiguring__table}&gt;
                  {tableColumns.length === 0 ? (
                    &lt;div className={s.ModelConfiguring__placeholder}&gt;
                      &lt;div className={s.ModelConfiguring__placeholderText}&gt;
                        Start simulation to get summary statistics
                      &lt;/div&gt;
                      &lt;Button
                        hoverVariant={ButtonVariant.ACTION}
                        rightIcon={&lt;SimulationIcon /&gt;}
                        uppercase
                        size=&quot;small&quot;
                        disabled={isLoading || selectedSimulationMode === -1}
                        onClick={handleRunSimulation}
                      &gt;
                        Run simulation
                      &lt;/Button&gt;
                    &lt;/div&gt;
                  ) : (
                    &lt;Table
                      showSorting
                      rows={tableRows.map((row) =&gt; {
                        if (selectedBatches.includes(row.BatchId.toString())) {
                          return {
                            ...row,
                            selected: true
                          };
                        }
                        return { ...row, selected: false };
                      })}
                      onRowClick={(row: any) =&gt; {
                        onChangeSelectedBatches((prev) =&gt;
                          prev.includes(row.BatchId)
                            ? prev.filter((d) =&gt; d !== row.BatchId)
                            : prev.concat(row.BatchId)
                        );
                      }}
                      columns={tableColumns.map((col) =&gt; ({
                        name: col,
                        title: col
                      }))}
                    /&gt;
                  )}
                &lt;/div&gt;
              &lt;/div&gt;
            &lt;/div&gt;
          &lt;/div&gt;
        &lt;/div&gt;
      &lt;/FormWrapper&gt;
    &lt;/div&gt;
  );
};
</textarea><pre id="annotations" style="display:none">[{&quot;file&quot;:&quot;src/pages/simulation/index.tsx&quot;,&quot;line&quot;:309,&quot;character&quot;:35,&quot;text&quot;:&quot;fields as GeneralSimulationFields&quot;,&quot;kind&quot;:3},{&quot;file&quot;:&quot;src/pages/simulation/index.tsx&quot;,&quot;line&quot;:311,&quot;character&quot;:37,&quot;text&quot;:&quot;fields as GeneralSimulationFields&quot;,&quot;kind&quot;:3},{&quot;file&quot;:&quot;src/pages/simulation/index.tsx&quot;,&quot;line&quot;:313,&quot;character&quot;:30,&quot;text&quot;:&quot;fields as GeneralSimulationFields&quot;,&quot;kind&quot;:3},{&quot;file&quot;:&quot;src/pages/simulation/index.tsx&quot;,&quot;line&quot;:319,&quot;character&quot;:37,&quot;text&quot;:&quot;fields as CentrifugePerfusionFields&quot;,&quot;kind&quot;:3},{&quot;file&quot;:&quot;src/pages/simulation/index.tsx&quot;,&quot;line&quot;:321,&quot;character&quot;:30,&quot;text&quot;:&quot;fields as CentrifugePerfusionFields&quot;,&quot;kind&quot;:3},{&quot;file&quot;:&quot;src/pages/simulation/index.tsx&quot;,&quot;line&quot;:323,&quot;character&quot;:36,&quot;text&quot;:&quot;fields as CentrifugePerfusionFields&quot;,&quot;kind&quot;:3},{&quot;file&quot;:&quot;src/pages/simulation/index.tsx&quot;,&quot;line&quot;:325,&quot;character&quot;:31,&quot;text&quot;:&quot;fields as CentrifugePerfusionFields&quot;,&quot;kind&quot;:3},{&quot;file&quot;:&quot;src/pages/simulation/index.tsx&quot;,&quot;line&quot;:327,&quot;character&quot;:35,&quot;text&quot;:&quot;fields as CentrifugePerfusionFields&quot;,&quot;kind&quot;:3},{&quot;file&quot;:&quot;src/pages/simulation/index.tsx&quot;,&quot;line&quot;:333,&quot;character&quot;:38,&quot;text&quot;:&quot;fields as IntensifiedGrowthFields&quot;,&quot;kind&quot;:3},{&quot;file&quot;:&quot;src/pages/simulation/index.tsx&quot;,&quot;line&quot;:335,&quot;character&quot;:37,&quot;text&quot;:&quot;fields as IntensifiedGrowthFields&quot;,&quot;kind&quot;:3},{&quot;file&quot;:&quot;src/pages/simulation/index.tsx&quot;,&quot;line&quot;:337,&quot;character&quot;:30,&quot;text&quot;:&quot;fields as IntensifiedGrowthFields&quot;,&quot;kind&quot;:3},{&quot;file&quot;:&quot;src/pages/simulation/index.tsx&quot;,&quot;line&quot;:343,&quot;character&quot;:35,&quot;text&quot;:&quot;fields as PerfusionOptimizerFields&quot;,&quot;kind&quot;:3},{&quot;file&quot;:&quot;src/pages/simulation/index.tsx&quot;,&quot;line&quot;:345,&quot;character&quot;:27,&quot;text&quot;:&quot;fields as PerfusionOptimizerFields&quot;,&quot;kind&quot;:3},{&quot;file&quot;:&quot;src/pages/simulation/index.tsx&quot;,&quot;line&quot;:346,&quot;character&quot;:30,&quot;text&quot;:&quot;fields as PerfusionOptimizerFields&quot;,&quot;kind&quot;:3},{&quot;file&quot;:&quot;src/pages/simulation/index.tsx&quot;,&quot;line&quot;:426,&quot;character&quot;:32,&quot;text&quot;:&quot;data as any&quot;,&quot;kind&quot;:3},{&quot;file&quot;:&quot;src/pages/simulation/index.tsx&quot;,&quot;line&quot;:427,&quot;character&quot;:13,&quot;text&quot;:&quot;data as any&quot;,&quot;kind&quot;:3},{&quot;file&quot;:&quot;src/pages/simulation/index.tsx&quot;,&quot;line&quot;:427,&quot;character&quot;:41,&quot;text&quot;:&quot;length&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/pages/simulation/index.tsx&quot;,&quot;line&quot;:442,&quot;character&quot;:8,&quot;text&quot;:&quot;viableCellDensity&quot;,&quot;kind&quot;:2},{&quot;file&quot;:&quot;src/pages/simulation/index.tsx&quot;,&quot;line&quot;:445,&quot;character&quot;:9,&quot;text&quot;:&quot;data as any&quot;,&quot;kind&quot;:3},{&quot;file&quot;:&quot;src/pages/simulation/index.tsx&quot;,&quot;line&quot;:445,&quot;character&quot;:45,&quot;text&quot;:&quot;map&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/pages/simulation/index.tsx&quot;,&quot;line&quot;:447,&quot;character&quot;:10,&quot;text&quot;:&quot;x&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/pages/simulation/index.tsx&quot;,&quot;line&quot;:447,&quot;character&quot;:14,&quot;text&quot;:&quot;data as any&quot;,&quot;kind&quot;:3},{&quot;file&quot;:&quot;src/pages/simulation/index.tsx&quot;,&quot;line&quot;:451,&quot;character&quot;:13,&quot;text&quot;:&quot;a&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/pages/simulation/index.tsx&quot;,&quot;line&quot;:451,&quot;character&quot;:16,&quot;text&quot;:&quot;b&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/pages/simulation/index.tsx&quot;,&quot;line&quot;:451,&quot;character&quot;:22,&quot;text&quot;:&quot;a&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/pages/simulation/index.tsx&quot;,&quot;line&quot;:451,&quot;character&quot;:24,&quot;text&quot;:&quot;x&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/pages/simulation/index.tsx&quot;,&quot;line&quot;:451,&quot;character&quot;:28,&quot;text&quot;:&quot;b&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/pages/simulation/index.tsx&quot;,&quot;line&quot;:451,&quot;character&quot;:30,&quot;text&quot;:&quot;x&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/pages/simulation/index.tsx&quot;,&quot;line&quot;:469,&quot;character&quot;:11,&quot;text&quot;:&quot;data as any&quot;,&quot;kind&quot;:3},{&quot;file&quot;:&quot;src/pages/simulation/index.tsx&quot;,&quot;line&quot;:469,&quot;character&quot;:47,&quot;text&quot;:&quot;map&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/pages/simulation/index.tsx&quot;,&quot;line&quot;:471,&quot;character&quot;:28,&quot;text&quot;:&quot;data as any&quot;,&quot;kind&quot;:3},{&quot;file&quot;:&quot;src/pages/simulation/index.tsx&quot;,&quot;line&quot;:472,&quot;character&quot;:14,&quot;text&quot;:&quot;x&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/pages/simulation/index.tsx&quot;,&quot;line&quot;:472,&quot;character&quot;:18,&quot;text&quot;:&quot;data as any&quot;,&quot;kind&quot;:3},{&quot;file&quot;:&quot;src/pages/simulation/index.tsx&quot;,&quot;line&quot;:477,&quot;character&quot;:15,&quot;text&quot;:&quot;a&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/pages/simulation/index.tsx&quot;,&quot;line&quot;:477,&quot;character&quot;:18,&quot;text&quot;:&quot;b&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/pages/simulation/index.tsx&quot;,&quot;line&quot;:477,&quot;character&quot;:24,&quot;text&quot;:&quot;a&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/pages/simulation/index.tsx&quot;,&quot;line&quot;:477,&quot;character&quot;:26,&quot;text&quot;:&quot;x&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/pages/simulation/index.tsx&quot;,&quot;line&quot;:477,&quot;character&quot;:30,&quot;text&quot;:&quot;b&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/pages/simulation/index.tsx&quot;,&quot;line&quot;:477,&quot;character&quot;:32,&quot;text&quot;:&quot;x&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/pages/simulation/index.tsx&quot;,&quot;line&quot;:479,&quot;character&quot;:34,&quot;text&quot;:&quot;row&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/pages/simulation/index.tsx&quot;,&quot;line&quot;:480,&quot;character&quot;:12,&quot;text&quot;:&quot;batchId&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/pages/simulation/index.tsx&quot;,&quot;line&quot;:481,&quot;character&quot;:10,&quot;text&quot;:&quot;row&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/pages/simulation/index.tsx&quot;,&quot;line&quot;:482,&quot;character&quot;:10,&quot;text&quot;:&quot;row&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/pages/simulation/index.tsx&quot;,&quot;line&quot;:482,&quot;character&quot;:14,&quot;text&quot;:&quot;BatchID&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/pages/simulation/index.tsx&quot;,&quot;line&quot;:483,&quot;character&quot;:12,&quot;text&quot;:&quot;time&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/pages/simulation/index.tsx&quot;,&quot;line&quot;:484,&quot;character&quot;:10,&quot;text&quot;:&quot;row&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/pages/simulation/index.tsx&quot;,&quot;line&quot;:485,&quot;character&quot;:10,&quot;text&quot;:&quot;row&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/pages/simulation/index.tsx&quot;,&quot;line&quot;:485,&quot;character&quot;:14,&quot;text&quot;:&quot;Time&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/pages/simulation/index.tsx&quot;,&quot;line&quot;:487,&quot;character&quot;:9,&quot;text&quot;:&quot;batchId&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/pages/simulation/index.tsx&quot;,&quot;line&quot;:487,&quot;character&quot;:19,&quot;text&quot;:&quot;row&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/pages/simulation/index.tsx&quot;,&quot;line&quot;:488,&quot;character&quot;:8,&quot;text&quot;:&quot;x&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/pages/simulation/index.tsx&quot;,&quot;line&quot;:488,&quot;character&quot;:11,&quot;text&quot;:&quot;time&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/pages/simulation/index.tsx&quot;,&quot;line&quot;:489,&quot;character&quot;:8,&quot;text&quot;:&quot;batchId&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/pages/simulation/index.tsx&quot;,&quot;line&quot;:495,&quot;character&quot;:8,&quot;text&quot;:&quot;variableSelector2&quot;,&quot;kind&quot;:2},{&quot;file&quot;:&quot;src/pages/simulation/index.tsx&quot;,&quot;line&quot;:500,&quot;character&quot;:9,&quot;text&quot;:&quot;data as any&quot;,&quot;kind&quot;:3},{&quot;file&quot;:&quot;src/pages/simulation/index.tsx&quot;,&quot;line&quot;:500,&quot;character&quot;:45,&quot;text&quot;:&quot;map&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/pages/simulation/index.tsx&quot;,&quot;line&quot;:501,&quot;character&quot;:15,&quot;text&quot;:&quot;data as any&quot;,&quot;kind&quot;:3},{&quot;file&quot;:&quot;src/pages/simulation/index.tsx&quot;,&quot;line&quot;:503,&quot;character&quot;:28,&quot;text&quot;:&quot;data as any&quot;,&quot;kind&quot;:3},{&quot;file&quot;:&quot;src/pages/simulation/index.tsx&quot;,&quot;line&quot;:504,&quot;character&quot;:14,&quot;text&quot;:&quot;x&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/pages/simulation/index.tsx&quot;,&quot;line&quot;:504,&quot;character&quot;:18,&quot;text&quot;:&quot;data as any&quot;,&quot;kind&quot;:3},{&quot;file&quot;:&quot;src/pages/simulation/index.tsx&quot;,&quot;line&quot;:508,&quot;character&quot;:18,&quot;text&quot;:&quot;time&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/pages/simulation/index.tsx&quot;,&quot;line&quot;:508,&quot;character&quot;:26,&quot;text&quot;:&quot;data as any&quot;,&quot;kind&quot;:3},{&quot;file&quot;:&quot;src/pages/simulation/index.tsx&quot;,&quot;line&quot;:510,&quot;character&quot;:20,&quot;text&quot;:&quot;rowTime&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/pages/simulation/index.tsx&quot;,&quot;line&quot;:510,&quot;character&quot;:31,&quot;text&quot;:&quot;row as any&quot;,&quot;kind&quot;:3},{&quot;file&quot;:&quot;src/pages/simulation/index.tsx&quot;,&quot;line&quot;:513,&quot;character&quot;:21,&quot;text&quot;:&quot;rowTime&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/pages/simulation/index.tsx&quot;,&quot;line&quot;:513,&quot;character&quot;:33,&quot;text&quot;:&quot;time&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/pages/simulation/index.tsx&quot;,&quot;line&quot;:516,&quot;character&quot;:28,&quot;text&quot;:&quot;row as any&quot;,&quot;kind&quot;:3},{&quot;file&quot;:&quot;src/pages/simulation/index.tsx&quot;,&quot;line&quot;:517,&quot;character&quot;:14,&quot;text&quot;:&quot;x&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/pages/simulation/index.tsx&quot;,&quot;line&quot;:517,&quot;character&quot;:18,&quot;text&quot;:&quot;data as any&quot;,&quot;kind&quot;:3},{&quot;file&quot;:&quot;src/pages/simulation/index.tsx&quot;,&quot;line&quot;:523,&quot;character&quot;:13,&quot;text&quot;:&quot;a&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/pages/simulation/index.tsx&quot;,&quot;line&quot;:523,&quot;character&quot;:16,&quot;text&quot;:&quot;b&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/pages/simulation/index.tsx&quot;,&quot;line&quot;:523,&quot;character&quot;:22,&quot;text&quot;:&quot;a&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/pages/simulation/index.tsx&quot;,&quot;line&quot;:523,&quot;character&quot;:24,&quot;text&quot;:&quot;x&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/pages/simulation/index.tsx&quot;,&quot;line&quot;:523,&quot;character&quot;:28,&quot;text&quot;:&quot;b&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/pages/simulation/index.tsx&quot;,&quot;line&quot;:523,&quot;character&quot;:30,&quot;text&quot;:&quot;x&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/pages/simulation/index.tsx&quot;,&quot;line&quot;:528,&quot;character&quot;:10,&quot;text&quot;:&quot;mappedRestrictedColumns&quot;,&quot;kind&quot;:2},{&quot;file&quot;:&quot;src/pages/simulation/index.tsx&quot;,&quot;line&quot;:530,&quot;character&quot;:20,&quot;text&quot;:&quot;project.project?.columns_map as any&quot;,&quot;kind&quot;:3},{&quot;file&quot;:&quot;src/pages/simulation/index.tsx&quot;,&quot;line&quot;:541,&quot;character&quot;:9,&quot;text&quot;:&quot;mappedRestrictedColumns&quot;,&quot;kind&quot;:2},{&quot;file&quot;:&quot;src/pages/simulation/index.tsx&quot;,&quot;line&quot;:559,&quot;character&quot;:10,&quot;text&quot;:&quot;fields as Fields&quot;,&quot;kind&quot;:3},{&quot;file&quot;:&quot;src/pages/simulation/index.tsx&quot;,&quot;line&quot;:562,&quot;character&quot;:57,&quot;text&quot;:&quot;fields as Fields&quot;,&quot;kind&quot;:3},{&quot;file&quot;:&quot;src/pages/simulation/index.tsx&quot;,&quot;line&quot;:780,&quot;character&quot;:35,&quot;text&quot;:&quot;row&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/pages/simulation/index.tsx&quot;,&quot;line&quot;:782,&quot;character&quot;:40,&quot;text&quot;:&quot;row&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/pages/simulation/index.tsx&quot;,&quot;line&quot;:782,&quot;character&quot;:44,&quot;text&quot;:&quot;BatchId&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/pages/simulation/index.tsx&quot;,&quot;line&quot;:783,&quot;character&quot;:55,&quot;text&quot;:&quot;row&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/pages/simulation/index.tsx&quot;,&quot;line&quot;:783,&quot;character&quot;:59,&quot;text&quot;:&quot;BatchId&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/pages/simulation/index.tsx&quot;,&quot;line&quot;:784,&quot;character&quot;:42,&quot;text&quot;:&quot;row&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/pages/simulation/index.tsx&quot;,&quot;line&quot;:784,&quot;character&quot;:46,&quot;text&quot;:&quot;BatchId&quot;,&quot;kind&quot;:1}]</pre></div>
    <p class="footer-text">TypeScript Coverage Report generated by <a href="https://github.com/plantain-00/type-coverage">type-coverage</a> and <a href="https://github.com/alexcanessa/typescript-coverage-report">typescript-coverage-report</a> at Tue, 05 Oct 2021 23:09:04 GMT</p>
    </body>
  </html>
  